//<?php
/**
 * 不正ログインプロテクター
 * 
 * 不正ログインを試みるアクセスを検出し、防御します
 *
 * @category    plugin
 * @version     1.1
 * @license     http://www.gnu.org/copyleft/gpl.html GNU Public License (GPL)
 * @internal    @events OnBeforeManagerLogin
 * @internal    @modx_category Manager and Admin
 */

$uri = $_SERVER['REQUEST_URI'];
if($_POST) $uri .= join('',$_POST);

if    (strpos($uri,',')!==false)  $type = 'A';
elseif(strpos($uri,'[]')!==false) $type = 'B';
elseif(strpos($uri,'?')!==false && !isset($_GET['hash']) && !isset($_GET['key'])) {
	$type = 'unknown';
}

switch($type)
{
	case 'A':
	case 'B':
	case 'unknown':
		$ip = $_SERVER['REMOTE_ADDR'];
		$info = print_r($_SERVER,true);
		if($_POST) $info .= print_r($_POST,true);
		$msg = "不正ログインを試みるアクセスを検出。防御しました。\nip : {$ip}\ntype : {$type}\ndetail:\n{$info}\n";
		if(isset($_REQUEST['username'])) $msg .= "\nusername : {$_GET['username']}";
		if(isset($_REQUEST['name'])) $msg .= "\nusername : {$_GET['name']}";
		if($type === 'unknown') $msg .= "\nuri : {$uri}";
		$msg = str_replace("\n" , "<br />\n", $msg);
		$modx->logEvent(0, 3, $msg,'Illegal Login Attack');
		$modx->sendUnauthorizedPage();
		exit;
		break;
	default:
		return;
}

